using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Threading;

namespace Analog
{
    public partial class Form1 : Form
    {
        Worker workerObject;    //[J[IuWFNg
        Thread workerThread;    //XbhCX^X
        public Form1()  //RXgN^
        {
            InitializeComponent();  //
        }

        private void DrawMeter(int val) // [^[`֐
        {
            int i;  // [vϐ
            float a, x, y;  // Wϊpϐ
            Graphics g = pictureBox1.CreateGraphics();//sN`[{bNX̑錾
            Point[] points = new Point[7];  //Ԃj̒_f[^쐬
            points[0] = new Point(270, 60); //_f[^0Zbg
            points[1] = new Point(258, 110); //_f[^1Zbg
            points[2] = new Point(267, 110); //_f[^2Zbg
            points[3] = new Point(267, 230); //_f[^3Zbg
            points[4] = new Point(273, 230); //_f[^4Zbg
            points[5] = new Point(273, 110); //_f[^5Zbg
            points[6] = new Point(282, 110); //_f[^6Zbg

            Image img1 = Properties.Resources.panel;    // C[W\[Xǂݍ
            g.DrawImage(img1, new Point(0, 0)); // [^[pl`
            
            a = (float)(Math.PI / 180 * (30 - (66 * val / 4096)));//UDPf[^j̊px֕ϊ
            for (i = 0; i < 7; i++)// 7̒_ׂĂ]
            {
                x = points[i].X - 270;  // _[^[SփVtg
                y = 494 - points[i].Y;  // _փVtg
                points[i].X = (int)(x * Math.Cos(a) - y * Math.Sin(a)) + 270;// X]
                points[i].Y = 494 - (int)(x * Math.Sin(a) + y * Math.Cos(a));// Y]
            }
            g.FillPolygon(Brushes.Red, points); // Ԃj`
            g.FillRectangle(Brushes.Black, 5, 226, 530, 11);    // [^[̘gĕ`
        }

        private void Form1_Load(object sender, EventArgs e)
        {   // tH[̋NɌĂ΂
            workerObject = new Worker();    // [J[IuWFNg쐬
            workerThread = new Thread(workerObject.DoUdp);  // XbhCX^XUDPXbhw
            workerThread.Start();   // UDPXbhJn
            while (!workerThread.IsAlive);  // UDPXbhJn҂
            Thread.Sleep(100);  // XbhɏsԂ^
        }

        private void timer1_Tick(object sender, EventArgs e)
        {   // ^C}[ŒIɌĂ΂
            DrawMeter(workerObject.GetUdpVal());    // \ŐV̏ԂɃAbvf[g
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {   // tH[鎞ɌĂ΂
            workerObject.RequestStop(); // UDPMXbhɒ~v
            while (workerThread.IsAlive)// XbhI҂
                Thread.Sleep(100);  // XbhɎsԂ^
        }
    }

    public class Worker
    {
        private volatile bool stopflag;     // ItO
        private static volatile int udpval; // Ugi[p̕ϐm

        // This method will be called when the thread is started.
        public void DoUdp()
        {
            String s;       //Mf[^i[p̕m
            System.Net.Sockets.UdpClient udp =    // UDPNCAg̑҂|[gw
                new System.Net.Sockets.UdpClient(30049);
            while (!stopflag) //f[^M
            {
                System.Net.IPEndPoint remoteEP = null;//@QƗp̃Gh|Cg쐬
                byte[] rcvBytes = udp.Receive(ref remoteEP);    //UDPf[^̓҂
                s = Encoding.UTF8.GetString(rcvBytes);  // GR[h𓾂
                udpval = int.Parse(s);  // 琔lɕϊĊi[
            }//UDPڑI
            udp.Close();        // UDPGh|CgJ
            stopflag = false;   // ItONA
        }
        public int GetUdpVal()  // ŐVUDPf[^̒l𓾂֐
        {
            return udpval;  // lĖ߂
        }
        public void RequestStop()   // XbhIv
        {
            stopflag = true;    //  ItOZbg
        }
    }

}